#include "SingleLinkList.h"
#include <stdlib.h>

int main(int argc, char* argv[])
{
	int i;
	LinkList* pListHead;	// A pointer to the header of a single linked list
	LinkList* pListNode;	// Single list node pointer
	LinkList* pListHeadTemp;
	
	//
	// Initializes the header node of a single linked list
	//
	pListHead = (LinkList*)malloc(sizeof(LinkList));
	pListHead->next = NULL;
	
	//
	// Initializes the nodes of a single list
	//
	for (i=8; i>0; i--)
	{
		pListNode = (LinkList*)malloc(sizeof(LinkList));
		pListNode->data = i;
		
		pListNode->next = pListHead->next;
		pListHead->next = pListNode;
	}
	
	//
	// Insert a node before the ith node
	//
	InsertBefore(pListHead, 3, 88);
	InsertBefore(pListHead, 20, 15);	// Invalid insert position. Insert failed.
	
	pListHeadTemp = pListHead;
	while (pListHeadTemp->next != NULL)
	{
		pListNode = pListHeadTemp->next;
		printf("%d ", pListNode->data);
		pListHeadTemp->next = pListNode->next;
	}
	printf("\n");
	
	//
	// Destroy single linked list
	//
	while (pListHead->next != NULL)
	{
		pListNode = pListHead->next;
		pListHead->next = pListNode->next;
		free(pListNode);
	}
	free(pListHead);

	return 0;
}

/*
function:
	Insert a node before the ith node.

parameter:
	pListHead -- A pointer to the head of a single linked list
	i -- The location of the insertion node.Count from 1.
	Elem -- Insert the value of the node.
	  
returned value:
	Returns 1 if insert succeeds
	Returns 0 if insert fails
*/
int InsertBefore(LinkList* pListHead, int i, ElemType Elem)
{
	LinkList* pListNode;	// Node pointer
	
	//
	// TODO: Add the code here
	//
	
	return 0;
}
